#ifndef TESTWID_H
#define TESTWID_H
#include <QWidget>
#include <QState>
#include <QStateMachine>
#include <QFinalState>
#include <QPushButton>
#include <QLabel>
#include <QVBoxLayout>
class TestWid : public QWidget{
    Q_OBJECT
    Q_DISABLE_COPY(TestWid)
public:
    explicit TestWid(QWidget* parent = Q_NULLPTR)
        :QWidget(parent)
    {
        m_textLabel=new QLabel(tr("Text1"),this);
        m_testButton=new QPushButton(tr("Press to Start"),this);
        QVBoxLayout* mainlay=new QVBoxLayout(this);
        mainlay->addWidget(m_textLabel);
        mainlay->addWidget(m_testButton);

        machine=new QStateMachine(this);
        s1=new QState;
        s1->assignProperty(m_textLabel,"text",tr("Text2"));
        s2=new QState;
        s2->assignProperty(m_textLabel,"text",tr("Text3"));
        s3 = new QFinalState();

        s1->addTransition(m_testButton, &QPushButton::clicked, s2);
        s2->addTransition(m_testButton, &QPushButton::clicked, s3);

        machine->addState(s1);
        machine->addState(s2);
        machine->addState(s3);
        machine->setInitialState(s1);
        machine->start();

    }
private:
    QLabel* m_textLabel;
    QPushButton* m_testButton;
    QStateMachine* machine;
    QState *s1;
    QState *s2;
    QFinalState *s3;
};

#endif // TESTWID_H




